﻿' Download and unzip the DotNetZip library at: http:'dotnetzip.codeplex.com/
' Add a reference to the Ionic.Zip.dll library.

Imports System.IO
imports Ionic.Zip

Public Class Form1

    ' Start with an initial file.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        txtFileName.Text = Path.GetFullPath( _
            Path.Combine(Application.StartupPath, "..\\..\\JackOLantern.bmp"))
        txtArchiveName.Text = Path.GetFullPath( _
            Path.Combine(Application.StartupPath, "..\\..\\JackOLantern.zip"))
        txtExtractTo.Text = Path.GetFullPath( _
            Path.Combine(Application.StartupPath, "..\\..\\ExtractedFiles\\"))
    End Sub

    ' Add the file to the archive.
    Private Sub btnAddToArchive_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddToArchive.Click
        Try
            Using zip As ZipFile = New ZipFile(txtArchiveName.Text)
                ' Add the file to the Zip archive's root folder.
                zip.AddFile(txtFileName.Text, txtPathInArchive.Text)

                ' Save the Zip file.
                zip.Save()
            End Using

            ' Display the file sizes.
            Dim old_fi As New FileInfo(txtFileName.Text)
            lblOriginalSize.Text = old_fi.Length.ToString("#,#")
            Dim new_fi As New FileInfo(txtArchiveName.Text)
            lblCompressedSize.Text = new_fi.Length.ToString("#,#")
            MessageBox.Show("Done")
        Catch ex As Exception
            MessageBox.Show("Error adding file to archive.\n" + ex.Message)
        End Try
    End Sub

    ' Extract the files from the archive.
    Private Sub btnExtractArchive_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExtractArchive.Click
        Try
            Using zip As ZipFile = ZipFile.Read(txtArchiveName.Text)
                ' Loop through the archive's files.
                For Each zip_entry As ZipEntry In zip
                    zip_entry.Extract(txtExtractTo.Text)
                Next zip_entry
            End Using

            MessageBox.Show("Done")
        Catch ex As Exception
            MessageBox.Show("Error extracting archive.\n" + ex.Message)
        End Try
    End Sub
End Class
